





                                                              Wombat Manual




                            THE GOLDEN WOMBAT OF DESTINY
                                         by
                                  Huw Collingbourne

                                * * * IMPORTANT * * *
                     ... a brief guide to starting the game ...

                              FILES NEEDED ON THE DISC:

          << NECESSARY FILES >>
          Your  copy  of  the  game  disc MUST include all of the following
          files. If any of them are missing, the game won't work!
               WOMBAT.COM     ( the main game file )
               NEW_ADV.000... ( the Overlay files which the game calls when
                    ...006    running.  See  the  file: 'Read.Txt' for full
                              details of all the  Overlay  files  which are
                              necessary to the current version ) 
               R.DAT          ( Data files... )
               O.DAT
               T.DAT
               REC.DAT

          << OPTIONAL FILES >>
          There are  several optional  files which you may wish to use such
          'Setup.Com',  'Colours.Alt'  and  'Read.Com'.  None  of  these is
          essential to  the game  but you  should read  the file 'Read.txt'
          before deleting any file from your game disc. To do  this, simply
          enter the  word READ  at the  Dos prompt.  You should also make a
          complete backup of the disc BEFORE altering anything. 

          STARTING THE GAME:
          "The Golden Wombat of Destiny" is an all text adventure  game. To
          get it started, you should type: 
                                       Wombat
          at the Dos prompt. Thereafter, you are on your own!

          NOTES ON THIS MANUAL:
          You are  not expected  to wade through this lot if you don't want
          to. You may find it handy to refer to the accepted vocabulary and
          the editing commands which you may use. The rest is for reference
          only ( e.g. if  you want  to change  the colours  ). However, you
          should at  least read  the notes  on SAVING  A GAME  and also the
          notes about MEMORY RESIDENT PROGRAMS.
                                * * * * * * * * * * *

                                                                     Page 1





                                                              Wombat Manual



          VOCABULARY:
          THE WORDS YOU CAN USE:

               The parser is not  one of  the most  sophisticated the world
          has ever  known (  nor, to  be truthful,  is it  one of the least
          sophisticated the computer adventure game has  ever known!  ). It
          understands a fairly rigidly fixed grammar and doesn't have a lot
          of time  for unnecessary  adjectives. It  rarely accepts plurals.
          Although  'trees'   would  be   OK,  'wombats'  and  'mice'  most
          definitely are not! Also, you may  only use  one complete command
          at a time. "Put the small bottle on the ground" is fine, but "Put
          the small bottle on the ground and open it." isn't. This goes for
          taking and dropping things too - get everything one at a time and
          don't try the old trick "take all", because you can't!
               If you don't care for  all  these  restrictions,  there are,
          nevertheless, some  positive points too. Unlike many other games,
          The Golden Wombat will  rarely  reject  an  input  command simply
          because there are one or two words that it does not understand.
               If possible,  it will always try to make some sense of input
          although this may mean that it has to  check that  you really did
          mean to say what it thinks you meant.
               For example, you might type in:
               "Listen to the acrobatic little wombat."
          The game  will politely(ish) inform you that it didn't understand
          all the words you used, but:
               "Do you want to listen to the wombat?
               ...Y/N"
          If you type 'Y',  then the  noises the  wombat is  making will be
          revealed in  all their wonderment. If you type 'N', then you will
          be free to go on and do something more boring.
               If you type in "I wandered lonely as a cloud  that floats on
          high  o'er  vale  and  hill,"  you  are likely to generate a less
          sympathetic response!

          This is a list of some of the  verbs which  The Golden  Wombat of
          Destiny currently understands:
                    break, drink,  drop, eat,  examine, get, hit,
                    kick,  kill,  listen,  look,  open,  pick up,
                    press,  pull,  push,  put, read, shout, shut,
                    smash, feel, give,  feed,  go,  drink, smell,
                    take, taste, throw, touch, wake.








                                                                     Page 2





                                                              Wombat Manual


          These commands may be used in various forms. All of the following
          examples would be quite  acceptable  (though  few  of  them would
          actually be useful!):
               "Kick the wall."
               "Throw the lamp at the door."
               "Put the mud in the keyhole."
               "Give the vegetation to the mouse."
               "Look inside the box"
               "Listen to the tree."
               "Kill the wombat with the sign." 

          Some of  the words  mentioned in  the text  may not be understood
          when you type them in. In particular, the room names  and various
          locations are  not in  the usable  vocabulary. Thus, although you
          may be told that there  is  a  'turret'  or  a  'tower'  near the
          'Ruined Area', none of these descriptions will be understood. Any
          semblance of intelligence in this game  (artificial or otherwise)
          is purely accidental!

          You  may  type  commands  in  upper or lower case. Punctuation is
          ignored, as are all numerals and extra spaces between words. 
               "PUt the Mo2USe Into     the  Box!", although  inelegant and
          also rather silly, would be OK.

          ABBREVIATED COMMANDS:
               Abbreviations which the game understands are all outlined in
          the Instruction window which you should view at the start  of the
          game (Type 'Y' when asked if you want instructions).
               Here is a brief summary of the most important ones:
                    'Q' : quit the game.
                    'L' : look.
                    'I' : Print an inventory (the things you are carrying).
                    'N','S','E','W','U','D' : 
                         Compass directions,  plus 'U'  for 'Go Up' and 'D'
                         for 'Go Down'. They get you around the game.
                    'Save', 'Restore' : 
                         saves a game or returns to the point  at which you
                         saved it. ( see notes which follow ).












                                                                     Page 3





                                                              Wombat Manual


          SAVING or RESTORING A GAME:
          You may  Save a  game at  any time by typing the word 'save'. You
          will then be prompted  for a  save file  name. You  may restore a
          previously saved  game by  typing 'restore'. The game is saved on
          the default save drive.  This will  be the  same drive  that your
          game disc  is in  unless you specify another drive when you first
          load the game - this may be done in the  'Help Window'  which may
          be entered  by typing  'Y' when  asked if  you'd like to read the
          Help notes or change the save  drive in  the opening  screen. The
          extension  '.Sav'  is  automatically  added to the name which you
          specify. If you experience  any  problems  with  the save/restore
          feature, you  should carefully  read the notes on Memory Resident
          Programs in this manual.

          INPUT FOR LAZY TYPISTS:
          In addition to the abbreviated commands, there are  several other
          ways in  which you may reduce the amount of typing you have to do
          in The Golden Wombat.

          ^R:
          To repeat your  last  command,  type  Control-R.  (hold  down the
          control button and the R). The entire command is repeated and may
          then be edited in the usual way.

          ^D:
          You may also repeat (and edit) a command by typing Control-D.    
             In this  case, your  previous command  will be  brought up one
          letter at a time, which allows you to alter it.  For example, you
          say "Take  the wombat".  You are told "The wombat isn't here."   
             You hold down Control-D. One letter a time "Take the " appears
          on screen once more. At this point you stop holding Control-D and
          enter some other word in place of "wombat".

          EDITING COMMANDS:
          To edit a command that you've typed in ( or retrieved with  ^D or
          ^R ),  use the  delete-backspace key |<--| rather than the cursor
          movement arrows.













                                                                     Page 4





                                                              Wombat Manual


          TECHNICAL STUFF:
          ( which is not very technical really - because neither am I! )

          'The Golden Wombat' was written in Pascal. Because of limitations
          of program  size, I have had to make fairly free use of overlays.
          If you are running the game from a floppy disc,  you will  hear a
          whirring  and  clanking  every  so  often as one of these overlay
          files is loaded  into  memory.  On  a  hard  disc  you'll  hear a
          slightly more pleasant chirruping noise when this happens. If you
          are running the game from a  RAM disc,  you'll miss  out on these
          simple pleasures.  I strongly recommend running from hard disc or
          RAM disc (a software program which you may or may  not have  - if
          you don't  know what  a RAM  disc is  then it's  probably safe to
          assume that you haven't got one!) in order  to reduce  the amount
          of time taken by accesses to disc. 

          SCORE:
          Much as in life, there is no scoring in The Golden Wombat.

          THE POINT:
          The  point  of  The  Golden  Wombat is Destiny itself. Obviously.
          You'll know when you've found it. Possibly.




























                                                                     Page 5





                                                              Wombat Manual


          SCREEN COLOURS:
          I wrote and tested  this game  on a  well-known Italian  brand of
          computer with  a colour graphics adaptor and a monochrome screen.
          As a result, the default colours  are set  to look  OK on  a mono
          screen with graphics card.
               Since  the  default  colours  may look pretty yuck! on other
          computer systems, I have allowed the colours to  be configured to
          your own  tastes. There  are two ways to do this. The easiest and
          prettiest way is to use the SETUP program.

          THE SETUP PROGRAM:
          To start this program, enter:
                    SetUp
          at the Dos prompt.
               The program allows you to define new colours  for The Golden
          Wombat. Note  that once  SetUp has  started, you  cannot leave it
          until you have completed your  colour  choices,  although  if you
          change  your  mind  about  your  chosen colours you are given the
          chance to ignore your definitions at the end of the program.
               SetUp shows you just what all  the chosen  colours will look
          like  as  you  actually  choose  them. When you are satisfied, it
          writes a  special  Colour  definition  file  called 'Colours.txt'
          which will re-define all the colours in the game itself.

          COLOURS.TXT:
          Colours.txt is a purely optional file. If it's not there the game
          will work anyway but it will use the default colours.
               If you'd like to change the colours but don't want to bother
          defining  your   own  colour  scheme,  you  could  try  out  some
          alternative  colour  files  included  on  the   disc.  They  are:
          Colours.Alt, Colours2.Alt  and Colours3.Alt.  Whichever one you'd
          like to try, you will first have to rename it: Colours.txt.
               For example, if you'd  like to  try out  the colours  set by
          Colours.Alt, you will need to enter at the dos prompt > 
                            REN COLOURS.ALT COLOURS.TXT 
          Colours.Alt  is  just  another  colour  scheme; Colours2.Alt is a
          fairly average  adventure game  colour scheme  in monochrome with
          the top status window in reverse highlight. Colours3.Alt prints a
          pretty frame around the top status line.











                                                                     Page 6





                                                              Wombat Manual



          !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                               * * *   WARNING   * * *
          !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

          MEMORY RESIDENT PROGRAMS:
          The saving and restoring of games may not work if memory resident
          programs are  loaded. Some  common examples  of such programs are
          'friendly interfaces' to DOS and utilities which may be called up
          on  top  of  other  programs.  These  include  SideKick, Windows,
          SuperKey, ProKey, Spoolers, RamDisks and Networking software.
               This does  not mean  that Save  and Restore  will never work
          when using these programs. In fact, they should not affect saving
          and restoring done in any one game session.  However, because The
          Wombat  saves  using  absolute  memory locations, Memory Resident
          Programs may screw up restores done at earlier  sessions. This is
          because the resident program may load itself into a bit of memory
          where The Wombat expects to find the things it has saved.
               If  you  absolutely  cannot  bear  to  be  without  resident
          proggies, then  at least  be consistent.  If you  always load the
          programs in exactly the same order and don't make any alterations
          to their  previous configurations, then your saves should restore
          without problem.
               To ensure that this is the case, you might like  to create a
          Batch file  using an  ordinary text  editor. An example of such a
          file might be:
                                     superdrv b:
                                          sk
                                          b:
                                        wombat
               The batch file must  then be  saved with  a '.Bat' extension
          Then, instead  of loading  the programs separately, you need only
          enter the name of the batch file at the Dos  prompt (for example,
          you would enter 'Wom' for a file called 'Wom.Bat'). 
               If you  are unsure  whether resident  programs are likely to
          affect your saves  then  <<  Always  save  your  current position
          BEFORE restoring  a game  saved from an earlier session >> If the
          restore fails you should  be able  to restore  your more recently
          saved game without problem.
               If a  restore has failed, you should get an error message to
          tell you so. You may also find that you have  been deposited back
          in the  mangrove swamp.  *** You  cannot play the game from here,
          however. You MUST restore a good save file ***







                                                                     Page 7





                                                              Wombat Manual


          NOTES FOR NOVICE ADVENTURERS:
          * Make a map. 
          * When you enter somewhere for the first time, you'll  be given a
          full  description  of  your  surroundings.  If you enter the same
          place later on, you'll only get the name  of the  place. The full
          description may be recalled if you type 'l' or 'look'. 
          *  'i'  is  a  very  useful  command. It prints a list of all the
          things you are carrying.
          * All of the puzzles may be solved from information  given in the
          game itself. Often you'll need to find a clue in order to solve a
          problem.

          Have fun....





































                                                                     Page 8
